"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
var lodash_1 = require("lodash");
var parseArgv_1 = __importDefault(require("./argsParser/parseArgv"));
var glob_1 = require("../util/glob");
var createMochapack_1 = __importDefault(require("../createMochapack"));
var optionsFromParsedArgs_1 = __importDefault(require("./argsParser/optionsFromParsedArgs"));
var exit = function (lazy, code) {
    if (lazy) {
        process.on('exit', function () {
            process.exit(code);
        });
    }
    else {
        process.exit(code);
    }
};
function cli() {
    return __awaiter(this, void 0, void 0, function () {
        var cliArgs, cliOptions, mochaWebpack, extensions, fallbackFileGlob, fileGlob;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    cliArgs = parseArgv_1["default"](process.argv.slice(2));
                    return [4 /*yield*/, optionsFromParsedArgs_1["default"](cliArgs)];
                case 1:
                    cliOptions = _a.sent();
                    mochaWebpack = createMochapack_1["default"](cliOptions);
                    extensions = lodash_1.get(cliOptions.webpack.config, 'resolve.extensions', [
                        '.js'
                    ]);
                    fallbackFileGlob = glob_1.extensionsToGlob(extensions);
                    fileGlob = cliOptions.mochapack.glob != null
                        ? cliOptions.mochapack.glob
                        : fallbackFileGlob;
                    cliOptions.mocha.cli.files.forEach(function (f) {
                        return mochaWebpack.addEntry(glob_1.ensureGlob(f, cliOptions.mocha.cli.recursive, fileGlob));
                    });
                    return [4 /*yield*/, Promise.resolve()
                            // @ts-ignore
                            .then(function () {
                            if (cliOptions.mocha.cli.watch) {
                                return mochaWebpack.watch();
                            }
                            return mochaWebpack.run();
                        })
                            .then(function (failures) {
                            exit(cliOptions.mocha.cli.exit, failures || 0);
                        })["catch"](function (e) {
                            if (e)
                                console.error(e.stack); // eslint-disable-line
                            exit(cliOptions.mocha.cli.exit, 1);
                        })];
                case 2:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    });
}
cli();
//# sourceMappingURL=index.js.map